config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  root 'static_pages#initial'
  get 'info_page', to: 'static_pages#info_page'
  get 'about', to: 'static_pages#about'
  resources :mems
  #   resources :mem_photos, only: :create
  # end 
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/memory.rb
class Memory < ApplicationRecord
  belongs_to :user
  # has_many :photos
  geocoded_by :location
  after_validation :geocode

  validates :mem, presence: true, length: {maximum: 30, minimun: 3}
  validates :mood, presence: true, length: {maximum: 30, minimun: 3}
  validates :thoughts, presence: true
  validates :date, presence: true
  validates :location, presence: true, length: {maximum: 30, minimun: 3}
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  validates :first_name, presence: true, length: {maximum: 30, minimun: 3}
  validates :last_name, presence: true, length: {maximum: 30, minimun: 3}

  has_many :memories
  # has_many :photos 
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
protect_from_forgery with: :exception, prepend: true

before_action :configure_permitted_parameters, if: :devise_controller?

  def after_sign_in_path_for(resource)
    stored_location_for(resource) || info_page_path
  end

protected

  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up) { |u| u.permit(:first_name, :last_name, :email, :password)}

    devise_parameter_sanitizer.permit(:account_update) { |u| u.permit(:first_name, :last_name, :email, :password, :current_password)}
  end
end

app/controllers/mems_controller.rb
class MemsController < ApplicationController
  before_action :authenticate_user!

  def index 
    @memories = current_user.memories.all
    if current_user.memories.blank? 
      redirect_to new_mem_path 
      flash[:alert] = "create a mem first"
    end 
  end 

  def new 
    @memory = Memory.new
  end

  def show 
    @memory = current_user.memories.find_by_id(params[:id])
    if @memory.blank?
      redirect_to mems_path
    end
  end

  def create
    @memory = current_user.memories.create(memory_params)
    if @memory.valid?
      redirect_to mems_path
    else 
      render :new, status: :unprocessable_entity 
    end
  end 

  def edit 
    @memory = current_user.memories.find_by_id(params[:id])
    if @memory.blank?
      redirect_to mems_path
      flash[:alert] = "Mem Not Found"
    end 
  end 

  def update 
    @memory = current_user.memories.find_by_id(params[:id])
    if @memory.blank?
      return redirect_to mems_path(current_user) 
      flash[:alert] = "Mem Not Found"
    end 
    @memory.update_attributes(memory_params)
    if @memory.valid?
      redirect_to mem_path(@memory)
    else 
      render :edit, status: :unprocessable_entity 
    end 
  end 

  def destroy
    @memory = current_user.memories.find_by_id(params[:id])
    if @memory.blank?
    return redirect_to mems_path(current_user) 
      flash[:alert] = "Mem Not Found"
    end 
    @memory.destroy
    redirect_to mems_path(current_user)
  end

  private

  def memory_params
    params.require(:memory).permit(:mem, :mood, :thoughts, :date, :location)
  end
end

app/controllers/static_pages_controller.rb
class StaticPagesController < ApplicationController
  attr_accessor :initial, :info_page, :about
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/mems_helper.rb
module MemsHelper
end

app/helpers/static_pages_helper.rb
module StaticPagesHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>mem</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
       <link href="https://fonts.googleapis.com/css?family=Playfair+Display&display=swap" rel="stylesheet">
  </head>

    <body>
      <% unless action_name == "initial" %>
        <div class="my-header">
          <div id="flex-content-container">
            <nav class="navbar navbar-toggleable-md navbar-inverse bg-inverse">
              <a class="navbar-brand" href= /info_page ><%= image_tag 'mem.png', class: 'mem' %></a>
                <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarTogglerDemo02" aria-controls="navbarTogglerDemo02" aria-expanded="false" aria-label="Toggle navigation">
                  <span class="navbar-toggler-icon"></span>
                </button>
         

                <div class="collapse navbar-collapse" id="navbarTogglerDemo02">
                  <ul class="navbar-nav">
                    <% if user_signed_in? %>
                      <li class="nav-item">
                        <%= link_to 'create mem',
                        new_mem_path, class: 'nav-link' %>
                      </li>
                      <li class="nav-item">
                        <%= link_to 'timeline', mems_path(current_user), class: 'nav-link' %>   
                      </li> 
                      <li class="nav-item">
                        <%= link_to 'sign out', destroy_user_session_path, method: :delete, class: 'nav-link' %>
                      </li>
                    <% else %>
                      <li class="nav-item">
                        <%= link_to 'sign in', new_user_session_path, class: 'nav-link' %>
                      </li>
                      <li class="nav-item">
                        <%= link_to 'sign up', new_user_registration_path, class: 'nav-link' %>
                      </li>
                    <% end %>
                  </ul>
                </div>
            </nav>
          </div>
        </div>
      <% end %>

      <div class="alert_style">
        <% if notice.present? %>
        <p class="alert alert-info"><%= notice %></p>
        <% end %>
        <% if alert.present? %>
          <p class="alert alert-danger"><%= alert %></p>
        <% end %>
      </div>

        <%= yield %>
      </div>
    </div>
  </body>
</html>

app/views/mems/edit.html.erb
<html>
  <head>
    <link href="https://fonts.googleapis.com/css?family=Playfair+Display&display=swap" rel="stylesheet">
  </head>
  <body>
    <div class="form_margin">
      <div class="booyah-box col-10 offset-1">
        <div align="center">
          <%= simple_form_for @memory, url: mem_path do |f| %>
          <%= f.input :mem %>
          <%= f.input :mood %>
          <%= f.input :thoughts %>
          <%= f.input :date %>
          <%= f.input :location %>
          <h3>suggestion: other than maybe fixing spelling mistakes, try to keep your mems the way they were. keep your first inital thoughts and feelings. that's what makes this cool.</h3> 
          <%= f.submit "update mem", class: 'btn btn-secondary' %>
          <% end %>
        </div>
      </div>
    </div>

app/views/mems/index.html.erb
<html>
  <head>
    <link href="https://fonts.googleapis.com/css?family=Playfair+Display&display=swap" rel="stylesheet">
  </head>
  <body>
    <div class="mem-timeline">
      <div align="center">
        <% @memories.reverse_each do |memory| %>
          <div class="mem_hover_line">
            <h1> | </h1>
          </div>
            <br />
          <div class="mem_hover">
            <h2><%= link_to memory.mem, mem_path(memory), {:style=>'color:#FFFFFF;', :class => "css_class"}  %></h2>
            <h3><%= memory.date.strftime("%B %d, %Y")%></h3>
            <br /> 
          </div> 
        <% end %>
      </div>
    </div>
  </body>
</html>

app/views/mems/new.html.erb
<html>
  <head>
    <link href="https://fonts.googleapis.com/css?family=Playfair+Display&display=swap" rel="stylesheet">
  </head>
  <body>
    <div class="form_margin">
      <div class="booyah-box col-10 offset-1">
        <div align="center">
          <% if current_user.memories.blank? %>
            <%= image_tag 'instruct.png', class: 'instruct' %>
          <% end %>
          <br />
              <%= simple_form_for @memory, url: mems_path do |f| %>
              <%= f.input :mem %>
              <%= f.input :mood %>
              <%= f.input :thoughts %>
              <%= f.input :date %>
              <%= f.input :location %>
              <%= f.submit "create", class: 'btn btn-secondary' %>
              <% end %>
        </div>
      </div>
    </div>

app/views/mems/show.html.erb
<html>
  <head>
  </head>
  <div class="form_margin">
    <div class="booyah-box col-10 offset-1">
      <div align="center"> 
        <body>
          <div style="border:0.1px; border-style:solid; border-color: white; padding: 0.1em;">
            <h2><%= @memory.mem %></h2>
            <h3>mood: <%= @memory.mood %></h3>
            <p><%= @memory.thoughts %></p>
          </div>

        <% if @memory.latitude.present? && @memory.longitude.present? %>
          <script>
            function initMap() {
              var myLatLng = {lat: <%= @memory.latitude %>, lng: <%= @memory.longitude %>};

              var map = new google.maps.Map(document.getElementById('map'), {
                zoom: 12,
                center: myLatLng
              });

              var marker = new google.maps.Marker({
                position: myLatLng,
                map: map,
                title: 'Hello World!'
              });
            }
          </script>

          <div id="map"></div>

        <% end %>

        <br />

          <script async defer
          src="https://maps.googleapis.com/maps/api/js?key=AIzaSyC1SbG-BOWcVj3ZbWVmXVBRd6DgBMJ4-pg&callback=initMap">
          </script>

          <h3><%= @memory.date.strftime("%B %d, %Y") %></h3>
        </body>
        <br />
        <div class="mem-edit">
          <% if current_user && current_user == @memory.user %>
            <%= link_to 'edit mem', edit_mem_path(@memory), class: 'btn btn-secondary' %>
            <%= link_to 'delete mem', mem_path(@memory), class: 'btn btn-secondary', method: :delete, data: {confirm: 'you sure you wanna delete this mem?'} %>
          <% end %>
        </div>
      </div>
    </div>
  </div>
</html>

app/views/static_pages/about.html.erb
<html>
  <head>
    <link href="https://fonts.googleapis.com/css?family=Playfair+Display&display=swap" rel="stylesheet">
  </head>
  <body>
    <a href= info_page ><%= image_tag 'aboutmem.png', class: 'about-mem' %></a>
  </body>
</html>

app/views/static_pages/info_page.html.erb
<html>
  <head>
  </head>
  <script>
    $(function() {
      $('.bookdrag').draggable({});
    });
  </script>
  <body>
    <a href= about ><%= image_tag 'about.png', class: 'about' %></a>
    <ul class="bookdrag">
      <%= image_tag 'book_two.png', class: 'book' %>
    </ul>
  </body>
</html>

app/views/static_pages/initial.html.erb
<html>
  <head>
  </head>
  <body>
    <div class="membook_logo">
      <a href= info_page ><%= image_tag 'mem.png', class: 'img-fluid' %></a>
    </div>
  </body>
</html>

app/views/static_pages/not_your_mem.html.erb
<html>
  <head>
  </head>
  <body>
    <h1> Not Your Mem </h1>
    <h1> See your Mems Here</h1>
    <%= link_to 'My Mems', mems_path, class: 'btn btn-secondary' %>
  </body>
</html>